#include "io430.h"
#include <stdbool.h>
#include <stdlib.h>

void initialize(void)
{
  static bool hasBeenCalled = false;
  if(!hasBeenCalled)
  {
    WDTCTL = WDTPW + WDTHOLD;
    P1DIR |= 0x41;
    ADC10CTL0 = SREF_1 | ADC10SHT_3 | REFON | ADC10ON;
    ADC10CTL1 = ADC10DIV_3 | INCH_10;
    
    hasBeenCalled = true;
  }
}

int getTemperature(void)
{
  static int oldTemperature = -1;
  
  ADC10CTL0 |= ENC | ADC10SC;
  while((ADC10CTL0 & ADC10BUSY) != 0)
  {}
  
  int newTemperature = ADC10MEM;
  
  if(oldTemperature != -1 && abs(newTemperature-oldTemperature)>13)
  {
    //warn();
  }
  
  oldTemperature = newTemperature;
  
  return newTemperature;
}

void switchLED(bool led)
{
  if(led)
  {
    P1OUT |= 1;
    P1OUT &= ~0x40;
  }
  else
  {
    P1OUT |= 0x40;
    P1OUT &= ~1;
  }
}